/* $Id: proxy.c,v 1.2 2008-08-05 22:37:34+09 satan Exp satan $ */
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/param.h>
#include <sys/time.h>
#include <signal.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <time.h>

#define SERVER_PORT     (unsigned short)8080
#define READ_TIMEOUT    (long)5
#define READ_BUF_SIZE   (10 * 1024 * 1024)  // 10MB
#define CONNECTION_TIMEOUT (long)60
#define NULL_SOCKET     (int)(-1)
    
/* 饤ȤΥǡ */
typedef struct _member {
    int		client;
    int         server;
    struct _member  *next, *prev;
}  Member;

static Member	*first_member = NULL;
static int	proxy_sock;	// ʬ listen Ƥ륽å
static int      log_fds;    // ե

void SetReuseaddr (int);
void SignalCallback(int);
Member *MemberCreate(int);
Member *MemberDelete(Member *);

/*ARGSUSED*/
int  main (int argc, char *argv[])
{
    int		ns, fdwidth, nr, nw, selected;
    Member	*cur, *next;
    struct sockaddr_in  server, client;
    fd_set	readmask;
    size_t	cl;
    struct timeval  *timeout, timeoutSet;
    char        buf[READ_BUF_SIZE];
    struct hostent	*serverhost;

    /* ʥϥɥΥåȥåפԤ */
/*     signal(SIGHUP,  SignalCallback); */
    signal(SIGINT,  SignalCallback);
    signal(SIGQUIT, SignalCallback);
    signal(SIGTERM, SignalCallback);

    /* open the logfile, if not opened */
    {
        struct tm   *t;
        time_t      ti;

        ti = time(&ti);
        t = localtime(&ti);
        
        snprintf(buf, READ_BUF_SIZE,
                 "PROXY-%04d%02d%02d%02d%02d%02d-%06d.log",
                 t->tm_year +1900, t->tm_mon +1, t->tm_mday, t->tm_hour, t->tm_min, t->tm_sec, getpid());
    }
    // log_fds = open(buf, O_CREAT | O_WRONLY | O_SYNC, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
    log_fds = open(buf, O_CREAT | O_WRONLY, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
    if (log_fds == -1) {
        perror("open");
        exit(1);
    }

    /* åȤ */
    proxy_sock = socket(AF_INET, SOCK_STREAM, 0);
    if (proxy_sock < 0) {
	perror("server: socket");
	exit(1);
    }

    /* å°ѹ */
    SetReuseaddr(proxy_sock);

    /* åȤݡȤ˷Ҥ */
    memset(&server, 0, sizeof(server));
    server.sin_family = AF_INET;
    server.sin_addr.s_addr = htonl(INADDR_ANY);
    server.sin_port = htons(SERVER_PORT);

    if (bind(proxy_sock, (struct sockaddr *)&server, sizeof(server)) < 0) {
	perror("server: bind");
	exit(1);
    }

    /* ³׵᤬ΤȤԵ */
    if (listen(proxy_sock, 5) < 0) {
	perror("server: listen");
	exit(1);
    }

    cl = sizeof(client);

    /*
     * ʲΥ롼פǥ饤ȤƱʥԤ
     * 	³׵
     * 	񤭤
     */
    for (;;) {
	/* 쥯ȥޥΥꥻå */
	FD_ZERO(&readmask);

	/* ³׵ԤĥåȤϿ */
	FD_SET(proxy_sock, &readmask);
	fdwidth = proxy_sock;

	/* ³饤Ȥν񤭹ߤԤĥåȤϿ */
	for (cur = first_member; cur; cur = cur->next) {
	    FD_SET(cur->client, &readmask);
	    if (cur->client > fdwidth)  fdwidth = cur->client;
            if (cur->server >= 0)
                FD_SET(cur->server, &readmask);
            if (cur->server > fdwidth)  fdwidth = cur->server;
	}
	fdwidth += 1;

	/* ФСॢȤ򥻥åȤ */
	if (first_member) {
	    /* ॢȻ֤Υå */
	    timeoutSet.tv_sec = READ_TIMEOUT;
	    timeoutSet.tv_usec = 0;
	    timeout = &timeoutSet;
	} else
	    timeout = NULL;
	
	/* ϤԤġϤȥ꥿󤹤 */
	selected = select(fdwidth, &readmask, NULL, NULL, timeout);
	if (selected < 0) {
	    perror("server: select");
            exit(1);
	}
	else if (selected == 0) {
            static int  tmo_cnt = 0;
	    /* select has returned by time out */
	    printf("select timeout\n");
            if (++tmo_cnt > (CONNECTION_TIMEOUT / READ_TIMEOUT)) {
                // disconnect all clients and servers.
                for (cur = first_member; cur; cur = next) {
                    next = MemberDelete(cur);
                }
                fprintf(stderr, "all client was disconnected\n");
                tmo_cnt = 0;
            }
	}
	else {
	    /* ³׵᤬С¨³ */
	    if (FD_ISSET(proxy_sock, &readmask)) {
		ns = accept(proxy_sock, (struct sockaddr *)&client, &cl);
		if (ns < 0) {
		    perror("server: accept");
		    exit(1);
		}
#ifdef DEBUG
		printf("connect request from %s port: %d\n",
		       inet_ntoa(client.sin_addr), ntohs(client.sin_port));
#endif
		/* ³ФϿ */
                cur = MemberCreate(ns);
	    }
	    
	    /* Фν񤭹ߤĴ٤ */
	    for (cur = first_member; cur; cur = next) {
		if (cur->client != NULL_SOCKET && FD_ISSET(cur->client, &readmask)) {
                    /* 饤ȤϤɤ */
                    nr = read(cur->client, buf, READ_BUF_SIZE);
                    if (nr == 0) {
                        // socket may be closed by the client
			/* Фȴ */
                        fprintf(stderr, "Client close\n");

			/* åȤĤƥХꥹȤä  */
			next = MemberDelete(cur);
		    } else if (nr < -1) {
                        perror("client read");
                        exit(1);
                    } else {
                        if (cur->server == NULL_SOCKET) {
                            // GET http://www.nikep.net:80/index.html HTTP/1.1
                            // Host: www.nikep.net:80
                            char host[BUFSIZ], port[6], *c, *d;
                            int  nport = 80, is_set;

                            is_set = 0;
                            c = buf;
                            do {
                                // fprintf(stderr, "buf[0x%x],c[0x%x][0x%x:%c]\n", buf, c, *c, *c);
                                for (; *c != 'H'; c++) ;
                                if (*(++c) == 'o' && *(++c) == 's' && *(++c) == 't' && *(++c) == ':') {
                                    for (c++; *c == ' ' || *c == '\t'; c++) ;
                                    for (d = host; *c != ':' && *c != '/' && *c != '\n' && *c != '\r'; c++, d++)
                                        *d = *c;
                                    *d = '\0';
                                    if (*c == ':') {
                                        d = port;
                                        for (; *c != '/' && *c && *c != '\n' && *c != '\r'; c++, d++)
                                            *d = *c;
                                        *d = '\0';
                                        nport = atoi(port);
                                    }
                                    is_set = 1;
                                }
                            } while (!is_set && (int)c < (int)(buf + READ_BUF_SIZE));
                            fprintf(stderr, "Target Host[%s]:[%d]\n", host, nport);
                            
                            cur->server = socket(AF_INET, SOCK_STREAM, 0);
                            if (cur->server < 0) {
                                perror("server: socket");
                                exit(1);
                            }
                            SetReuseaddr(cur->server);

                            /* åȤݡȤ˷Ҥ */
                            serverhost = gethostbyname(host);
                            if (!serverhost) {
                                herror("gethostbyname");
                                perror("gethostbyname");
                                exit(1);
                            }
                            {
                                struct in_addr  ia;
                                memcpy(&ia, serverhost->h_addr, sizeof(ia));
                                fprintf(stderr, "Gethostbyname: %s : %s\n", serverhost->h_name, inet_ntoa(ia));
                            }
                            memset(&server, 0, sizeof(server));
                            server.sin_family = AF_INET;
                            server.sin_port = htons(nport);
                            memcpy(&server.sin_addr, serverhost->h_addr, serverhost->h_length);
                            if (connect(cur->server, (struct sockaddr *)&server, sizeof(server)) < 0) {
                                perror("server: connect");
                                exit(1);
                            }
                        }
                        do {
                            fprintf(stderr, "%d->%d:client_read:[%d]\n", cur->client, cur->server, nr);
                            nw = write(log_fds, buf, nr);
                            if (nw < 0 || nw < nr) {
                                perror("write to file");
                            }
                            nw = write(cur->server, buf, nr);
                            if (nw < 0 || nw < nr) {
                                perror("write to server");
                            }
                        } while (nr >= READ_BUF_SIZE &&
                                 (nr = read(cur->client, buf, READ_BUF_SIZE)) > 0);
                        next = cur->next;
                    }
                } else if (cur->server != NULL_SOCKET && FD_ISSET(cur->server, &readmask)) {
                    /* client ˱֤ */
                    nr = read(cur->server, buf, READ_BUF_SIZE);
                    if (nr == 0) {
                        /* socket closed by the serverХꥹȤ */
                        next = MemberDelete(cur);
                    } else if (nr < 0) {
                        perror("server read");
                        exit(1);
                    } else {
                        do {
                            fprintf(stderr, "%d->%d:server_read:[%d]\n", cur->server, cur->client, nr);
                            nw = write(log_fds, buf, nr);
                            if (nw < 0) {
                                perror("file write");
                                exit(1);
                            }
                            nw = write(cur->client, buf, nr);
                            if (nw < 0) {
                                perror("client write");
                                exit(1);
                            }
                        } while (nr >= READ_BUF_SIZE &&
                                 (nr = read(cur->server, buf, READ_BUF_SIZE)) > 0);
                        next = cur->next;
                    }
		} else {
		    next = cur->next;
                }
	    }
	}
    }
}

/* signal handler */
void  SignalCallback (int sig)
{
    Member  *member;

    fprintf(stderr, "SignalCode: %d\n", sig);
    
    close(proxy_sock);
    close(log_fds);

    for (member = first_member; member; member = member->next) {
        close(member->client);
        close(member->server);
    }

    fprintf(stderr, "soon terminate\n");
    exit(0);
}

/* REUSEADDR attribute ꤹ */
void SetReuseaddr (int sock)
{
#ifdef REUSEADDR
    int	flag;
    size_t	size;
	
    size = sizeof(flag);
    if (getsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &flag, &size) < 0) {
        perror("server: getsockopt");
    } else {
        printf("socket option(reuseaddr): (%d)\n", flag);
    }

    flag = 1;
    if (setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &flag, size) < 0) {
        perror("server: setsockopt");
    }
#else
#endif
}

/* Create Member structure */
Member *MemberCreate(int csock)
{
    Member *cur = (Member *)malloc(sizeof(Member));
    if (!cur) {
        perror("server: malloc");
        exit(1);
    }
    cur->client = csock;
    cur->server = NULL_SOCKET;
    cur->next = first_member, cur->prev = NULL;
    if (first_member)  first_member->prev = cur;
    first_member = cur;

    return cur;
}
    

/* Delete the member, and returns the next member */
Member *MemberDelete(Member *cur)
{
    Member *next;
    
    if (cur->client != NULL_SOCKET) {
        if (close(cur->client) < 0) {
            perror("client: close");
        }
    }
    if (cur->server != NULL_SOCKET) {
        if (close(cur->server)) {
            perror("server: close");
        }
    }

    if (cur->prev) cur->prev->next = cur->next;
    if (cur->next) cur->next->prev = cur->prev;
    if (cur == first_member)  first_member = cur->next;
    next = cur->next;
    free(cur);
    return next;
}
